summaryrefslogtreecommitdiff
path: root/util/ci/lint.sh
diff options
context:
space:
mode:
authorLoïc Blot <nerzhul@users.noreply.github.com>2020-04-20 20:18:40 +0200
committerGitHub <noreply@github.com>2020-04-20 20:18:40 +0200
commit27a485a472706bededf38f0de2630688739ca0b2 (patch)
treea9eebf3c383e68d5856eddf1c608a427f2d7445b /util/ci/lint.sh
parent338195ff250bd7552ef8167348de2eb05e421c29 (diff)
downloadminetest-27a485a472706bededf38f0de2630688739ca0b2.tar.gz
minetest-27a485a472706bededf38f0de2630688739ca0b2.tar.bz2
minetest-27a485a472706bededf38f0de2630688739ca0b2.zip
Replace travis with github actions (#9641)
* Move outside of travis to Github actions This will permit to have better integrated CI workflow than the previous travis one.
Diffstat (limited to 'util/ci/lint.sh')
-rw-r--r--util/ci/lint.sh43
1 files changed, 43 insertions, 0 deletions
diff --git a/util/ci/lint.sh b/util/ci/lint.sh
new file mode 100644
index 000000000..395445ca7
--- /dev/null
+++ b/util/ci/lint.sh
@@ -0,0 +1,43 @@
+#! /bin/bash
+function perform_lint() {
+ echo "Performing LINT..."
+ if [ -z "${CLANG_FORMAT}" ]; then
+ CLANG_FORMAT=clang-format
+ fi
+ echo "LINT: Using binary $CLANG_FORMAT"
+ CLANG_FORMAT_WHITELIST="util/ci/clang-format-whitelist.txt"
+
+ files_to_lint="$(find src/ -name '*.cpp' -or -name '*.h')"
+
+ local errorcount=0
+ local fail=0
+ for f in ${files_to_lint}; do
+ d=$(diff -u "$f" <(${CLANG_FORMAT} "$f") || true)
+
+ if ! [ -z "$d" ]; then
+ whitelisted=$(awk '$1 == "'$f'" { print 1 }' "$CLANG_FORMAT_WHITELIST")
+
+ # If file is not whitelisted, mark a failure
+ if [ -z "${whitelisted}" ]; then
+ errorcount=$((errorcount+1))
+
+ printf "The file %s is not compliant with the coding style" "$f"
+ if [ ${errorcount} -gt 50 ]; then
+ printf "\nToo many errors encountered previously, this diff is hidden.\n"
+ else
+ printf ":\n%s\n" "$d"
+ fi
+
+ fail=1
+ fi
+ fi
+ done
+
+ if [ "$fail" = 1 ]; then
+ echo "LINT reports failure."
+ exit 1
+ fi
+
+ echo "LINT OK"
+}
+